| Flutter Impeller |

Public Member Functions | List of all members
impeller::SurfaceContextVK Class Reference

`#include <surface_context_vk.h>`

Inheritance diagram for impeller::SurfaceContextVK:

## Public Member Functions
| SurfaceContextVK (const std::shared_ptr< ContextVK > &parent)
| ~SurfaceContextVK () override
BackendType | GetBackendType () const override
| Get the graphics backend of an Impeller context. More...
std::string | DescribeGpuModel () const override
bool | IsValid () const override
| Determines if a context is valid. If the caller ever receives an invalid context, they must discard it and construct a new context. There is no recovery mechanism to repair a bad context. More...
std::shared_ptr< Allocator > | GetResourceAllocator () const override
| Returns the allocator used to create textures and buffers on the device. More...
std::shared_ptr< ShaderLibrary > | GetShaderLibrary () const override
| Returns the library of shaders used to specify the programmable stages of a pipeline. More...
std::shared_ptr< SamplerLibrary > | GetSamplerLibrary () const override
| Returns the library of combined image samplers used in shaders. More...
std::shared_ptr< PipelineLibrary > | GetPipelineLibrary () const override
| Returns the library of pipelines used by render or compute commands. More...
std::shared_ptr< CommandBuffer > | CreateCommandBuffer () const override
| Create a new command buffer. Command buffers can be used to encode graphics, blit, or compute commands to be submitted to the device. More...
const std::shared_ptr< const Capabilities > & | GetCapabilities () const override
| Get the capabilities of Impeller context. All optionally supported feature of the platform, client-rendering API, and device can be queried using the `Capabilities`. More...
std::shared_ptr< CommandQueue > | GetCommandQueue () const override
| Return the graphics queue for submitting command buffers. More...
std::shared_ptr< const IdleWaiter > | GetIdleWaiter () const override
RuntimeStageBackend | GetRuntimeStageBackend () const override
| Retrieve the runtime stage for this context type. More...
bool | SubmitOnscreen (std::shared_ptr< CommandBuffer > cmd_buffer) override
| Submit the command buffer that renders to the onscreen surface. More...
void | Shutdown () override
| Force all pending asynchronous work to finish. This is achieved by deleting all owned concurrent message loops. More...
bool | SetWindowSurface (vk::UniqueSurfaceKHR surface, const ISize &size)
bool | SetSwapchain (std::shared_ptr< SwapchainVK > swapchain)
std::unique_ptr< Surface > | AcquireNextSurface ()
void | MarkFrameEnd ()
| Performs frame incrementing processes like AcquireNextSurface but without the surface. More...
void | UpdateSurfaceSize (const ISize &size) const
| Mark the current swapchain configuration as dirty, forcing it to be recreated on the next frame. More...
void | TeardownSwapchain ()
| Can be called when the surface is destroyed to reduce memory usage. More...
void | InitializeCommonlyUsedShadersIfNeeded () const override
void | DisposeThreadLocalCachedResources () override
const vk::Device & | GetDevice () const
const std::shared_ptr< ContextVK > & | GetParent () const
bool | EnqueueCommandBuffer (std::shared_ptr< CommandBuffer > command_buffer) override
| Enqueue command_buffer for submission by the end of the frame. More...
bool | FlushCommandBuffers () override
| Flush all pending command buffers. More...
Public Member Functions inherited from impeller::Context
virtual | ~Context ()
| Destroys an Impeller context. More...
virtual bool | UpdateOffscreenLayerPixelFormat (PixelFormat format)
virtual void | StoreTaskForGPU (const fml::closure &task, const fml::closure &failure)
virtual bool | AddTrackingFence (const std::shared_ptr< Texture > &texture) const
virtual void | ResetThreadLocalState () const
const Flags & | GetFlags () const

## Additional Inherited Members
Public Types inherited from impeller::Context
enum class | BackendType { kMetal , kOpenGLES , kVulkan }
Static Public Member Functions inherited from impeller::BackendCast< SurfaceContextVK, Context >
static SurfaceContextVK & | Cast (Context &base)
static const SurfaceContextVK & | Cast (const Context &base)
static SurfaceContextVK * | Cast (Context *base)
static const SurfaceContextVK * | Cast (const Context *base)
Static Public Attributes inherited from impeller::Context
static constexpr int32_t | kMaxTasksAwaitingGPU = 1024
Protected Member Functions inherited from impeller::Context
| Context (const Flags &flags)
Protected Attributes inherited from impeller::Context
Flags | flags_
std::vector< std::function< void()> > | per_frame_task_

## Detailed Description

For Vulkan, there is both a ContextVK that implements Context and a SurfaceContextVK that also implements Context and takes a ContextVK as its parent. There is a one to many relationship between ContextVK and SurfaceContextVK.

Most operations in this class are delegated to the parent ContextVK. This class specifically manages swapchains and creation of VkSurfaces on Android. By maintaining the swapchain this way, it is possible to have multiple surfaces sharing the same ContextVK without stepping on each other's swapchains.

Definition at line 32 of file surface_context_vk.h.

## Constructor & Destructor Documentation

## ◆ SurfaceContextVK()

impeller::SurfaceContextVK::SurfaceContextVK | ( | const std::shared_ptr< ContextVK > & | parent | ) |
| explicit

Definition at line 16 of file surface_context_vk.cc.

17 : Context(parent->GetFlags()), parent_(parent) {}
impeller::Context::Context
Context(const Flags &flags)
Definition: context.cc:27

## ◆ ~SurfaceContextVK()

impeller::SurfaceContextVK::~SurfaceContextVK | ( |  | ) |
| overridedefault

## Member Function Documentation

## ◆ AcquireNextSurface()

std::unique_ptr< Surface > impeller::SurfaceContextVK::AcquireNextSurface | ( |  | ) |

Definition at line 91 of file surface_context_vk.cc.

91 {
92 TRACE_EVENT0("impeller", __FUNCTION__);
93 auto surface = swapchain_ ? swapchain_->AcquireNextDrawable() : nullptr;
94 if (!surface) {
95 return nullptr;
96 }
97 MarkFrameEnd();
98 return surface;
99 }
impeller::SurfaceContextVK::MarkFrameEnd
void MarkFrameEnd()
Performs frame incrementing processes like AcquireNextSurface but without the surface.
Definition: surface_context_vk.cc:101

References MarkFrameEnd().

Referenced by impeller::testing::TEST().

## ◆ CreateCommandBuffer()

std::shared_ptr< CommandBuffer > impeller::SurfaceContextVK::CreateCommandBuffer | ( |  | ) | const
| overridevirtual

Create a new command buffer. Command buffers can be used to encode graphics, blit, or compute commands to be submitted to the device.

A command buffer can only be used on a single thread. Multi-threaded render, blit, or compute passes must create a new command buffer on each thread.

Returns
  A new command buffer.

Implements impeller::Context.

Definition at line 49 of file surface_context_vk.cc.

49 {
50 return parent_->CreateCommandBuffer();
51 }

## ◆ DescribeGpuModel()

std::string impeller::SurfaceContextVK::DescribeGpuModel | ( |  | ) | const
| overridevirtual

Implements impeller::Context.

Definition at line 25 of file surface_context_vk.cc.

25 {
26 return parent_->DescribeGpuModel();
27 }

## ◆ DisposeThreadLocalCachedResources()

void impeller::SurfaceContextVK::DisposeThreadLocalCachedResources | ( |  | ) |
| overridevirtual

Dispose resources that are cached on behalf of the current thread.

Some backends such as Vulkan may cache resources that can be reused while executing a rendering operation. This API can be called after the operation completes in order to clear the cache.

Reimplemented from impeller::Context.

Definition at line 122 of file surface_context_vk.cc.

122 {
123 parent_->DisposeThreadLocalCachedResources();
124 }

## ◆ EnqueueCommandBuffer()

bool impeller::SurfaceContextVK::EnqueueCommandBuffer | ( | std::shared_ptr< CommandBuffer > | command_buffer | ) |
| overridevirtual

Enqueue command_buffer for submission by the end of the frame.

Certain backends may immediately flush the command buffer if batch submission is not supported. This functionality is not thread safe and should only be used via the ContentContext for rendering a 2D workload.

Returns true if submission has succeeded. If the buffer is enqueued then no error may be returned until FlushCommandBuffers is called.

Reimplemented from impeller::Context.

Definition at line 130 of file surface_context_vk.cc.

131 {
132 return parent_->EnqueueCommandBuffer(std::move(command_buffer));
133 }

## ◆ FlushCommandBuffers()

bool impeller::SurfaceContextVK::FlushCommandBuffers | ( |  | ) |
| overridevirtual

Flush all pending command buffers.

Returns whether or not submission was successful. This functionality is not threadsafe and should only be used via the ContentContext for rendering a 2D workload.

Reimplemented from impeller::Context.

Definition at line 135 of file surface_context_vk.cc.

135 {
136 return parent_->FlushCommandBuffers();
137 }

## ◆ GetBackendType()

Context::BackendType impeller::SurfaceContextVK::GetBackendType | ( |  | ) | const
| overridevirtual

Get the graphics backend of an Impeller context.

            This is useful for cases where a renderer needs to track and
            lookup backend-specific resources, like shaders or uniform
            layout information.

            It's not recommended to use this as a substitute for
            per-backend capability checking. Instead, check for specific
            capabilities via `GetCapabilities()`.

Returns
  The graphics backend of the `Context`.

Implements impeller::Context.

Definition at line 21 of file surface_context_vk.cc.

21 {
22 return parent_->GetBackendType();
23 }

## ◆ GetCapabilities()

const std::shared_ptr< const Capabilities > & impeller::SurfaceContextVK::GetCapabilities | ( |  | ) | const
| overridevirtual

Get the capabilities of Impeller context. All optionally supported feature of the platform, client-rendering API, and device can be queried using the `Capabilities`.

Returns
  The capabilities. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 57 of file surface_context_vk.cc.

58 {
59 return parent_->GetCapabilities();
60 }

## ◆ GetCommandQueue()

std::shared_ptr< CommandQueue > impeller::SurfaceContextVK::GetCommandQueue | ( |  | ) | const
| overridevirtual

Return the graphics queue for submitting command buffers.

Implements impeller::Context.

Definition at line 53 of file surface_context_vk.cc.

53 {
54 return parent_->GetCommandQueue();
55 }

## ◆ GetDevice()

const vk::Device & impeller::SurfaceContextVK::GetDevice | ( |  | ) | const

Definition at line 114 of file surface_context_vk.cc.

114 {
115 return parent_->GetDevice();
116 }

## ◆ GetIdleWaiter()

std::shared_ptr< const IdleWaiter > impeller::SurfaceContextVK::GetIdleWaiter | ( |  | ) | const
| overridevirtual

Reimplemented from impeller::Context.

Definition at line 62 of file surface_context_vk.cc.

62 {
63 return parent_->GetIdleWaiter();
64 }

## ◆ GetParent()

const std::shared_ptr< ContextVK > & impeller::SurfaceContextVK::GetParent | ( |  | ) | const

Definition at line 126 of file surface_context_vk.cc.

126 {
127 return parent_;
128 }

Referenced by impeller::testing::TEST_P().

## ◆ GetPipelineLibrary()

std::shared_ptr< PipelineLibrary > impeller::SurfaceContextVK::GetPipelineLibrary | ( |  | ) | const
| overridevirtual

Returns the library of pipelines used by render or compute commands.

Returns
  The pipeline library. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 45 of file surface_context_vk.cc.

45 {
46 return parent_->GetPipelineLibrary();
47 }

## ◆ GetResourceAllocator()

std::shared_ptr< Allocator > impeller::SurfaceContextVK::GetResourceAllocator | ( |  | ) | const
| overridevirtual

Returns the allocator used to create textures and buffers on the device.

Returns
  The resource allocator. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 33 of file surface_context_vk.cc.

33 {
34 return parent_->GetResourceAllocator();
35 }

## ◆ GetRuntimeStageBackend()

RuntimeStageBackend impeller::SurfaceContextVK::GetRuntimeStageBackend | ( |  | ) | const
| overridevirtual

Retrieve the runtime stage for this context type.

This is used by the engine shell and other subsystems for loading the correct shader types.

Implements impeller::Context.

Definition at line 145 of file surface_context_vk.cc.

145 {
146 return parent_->GetRuntimeStageBackend();
147 }

## ◆ GetSamplerLibrary()

std::shared_ptr< SamplerLibrary > impeller::SurfaceContextVK::GetSamplerLibrary | ( |  | ) | const
| overridevirtual

Returns the library of combined image samplers used in shaders.

Returns
  The sampler library. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 41 of file surface_context_vk.cc.

41 {
42 return parent_->GetSamplerLibrary();
43 }

## ◆ GetShaderLibrary()

std::shared_ptr< ShaderLibrary > impeller::SurfaceContextVK::GetShaderLibrary | ( |  | ) | const
| overridevirtual

Returns the library of shaders used to specify the programmable stages of a pipeline.

Returns
  The shader library. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 37 of file surface_context_vk.cc.

37 {
38 return parent_->GetShaderLibrary();
39 }

## ◆ InitializeCommonlyUsedShadersIfNeeded()

void impeller::SurfaceContextVK::InitializeCommonlyUsedShadersIfNeeded | ( |  | ) | const
| overridevirtual

Run backend specific additional setup and create common shader variants.

This bootstrap is intended to improve the performance of several first frame benchmarks that are tracked in the flutter device lab. The workload includes initializing commonly used but not default shader variants, as well as forcing driver initialization.

Reimplemented from impeller::Context.

Definition at line 118 of file surface_context_vk.cc.

118 {
119 parent_->InitializeCommonlyUsedShadersIfNeeded();
120 }

## ◆ IsValid()

bool impeller::SurfaceContextVK::IsValid | ( |  | ) | const
| overridevirtual

Determines if a context is valid. If the caller ever receives an invalid context, they must discard it and construct a new context. There is no recovery mechanism to repair a bad context.

It is convention in Impeller to never return an invalid context from a call that returns an pointer to a context. The call implementation performs validity checks itself and return a null context instead of a pointer to an invalid context.

How a context goes invalid is backend specific. It could happen due to device loss, or any other unrecoverable error.

Returns
  If the context is valid.

Implements impeller::Context.

Definition at line 29 of file surface_context_vk.cc.

29 {
30 return parent_->IsValid();
31 }

## ◆ MarkFrameEnd()

void impeller::SurfaceContextVK::MarkFrameEnd | ( |  | ) |

Performs frame incrementing processes like AcquireNextSurface but without the surface.

Used by the embedder.h implementations.

Definition at line 101 of file surface_context_vk.cc.

101 {
102 if (auto pipeline_library = parent_->GetPipelineLibrary()) {
103 impeller::PipelineLibraryVK::Cast(*pipeline_library)
104 .DidAcquireSurfaceFrame();
105 }
106 parent_->DisposeThreadLocalCachedResources();
107 parent_->GetResourceAllocator()->DebugTraceMemoryStatistics();
108 }
impeller::BackendCast< PipelineLibraryVK, PipelineLibrary >::Cast
static PipelineLibraryVK & Cast(PipelineLibrary &base)
Definition: backend_cast.h:13
impeller::PipelineLibraryVK::DidAcquireSurfaceFrame
void DidAcquireSurfaceFrame()
Definition: pipeline_library_vk.cc:277

References impeller::BackendCast< PipelineLibraryVK, PipelineLibrary >::Cast(), and impeller::PipelineLibraryVK::DidAcquireSurfaceFrame().

Referenced by AcquireNextSurface().

## ◆ SetSwapchain()

bool impeller::SurfaceContextVK::SetSwapchain | ( | std::shared_ptr< SwapchainVK > | swapchain | ) |

Definition at line 82 of file surface_context_vk.cc.

82 {
83 if (!swapchain || !swapchain->IsValid()) {
84 VALIDATION_LOG << "Invalid swapchain.";
85 return false;
86 }
87 swapchain_ = std::move(swapchain);
88 return true;
89 }
VALIDATION_LOG
#define VALIDATION_LOG
Definition: validation.h:91

References VALIDATION_LOG.

Referenced by SetWindowSurface().

## ◆ SetWindowSurface()

bool impeller::SurfaceContextVK::SetWindowSurface | ( | vk::UniqueSurfaceKHR | surface,
|  | const ISize & | size
| ) |  |

Definition at line 70 of file surface_context_vk.cc.

71 {
72 return SetSwapchain(SwapchainVK::Create(parent_, std::move(surface), size));
73 }
impeller::SurfaceContextVK::SetSwapchain
bool SetSwapchain(std::shared_ptr< SwapchainVK > swapchain)
Definition: surface_context_vk.cc:82
impeller::SwapchainVK::Create
static std::shared_ptr< SwapchainVK > Create(const std::shared_ptr< Context > &context, vk::UniqueSurfaceKHR surface, const ISize &size, bool enable_msaa=true)
Definition: swapchain_vk.cc:18

References impeller::SwapchainVK::Create(), and SetSwapchain().

Referenced by impeller::testing::TEST().

## ◆ Shutdown()

void impeller::SurfaceContextVK::Shutdown | ( |  | ) |
| overridevirtual

Force all pending asynchronous work to finish. This is achieved by deleting all owned concurrent message loops.

Implements impeller::Context.

Definition at line 66 of file surface_context_vk.cc.

66 {
67 parent_->Shutdown();
68 }

## ◆ SubmitOnscreen()

bool impeller::SurfaceContextVK::SubmitOnscreen | ( | std::shared_ptr< CommandBuffer > | cmd_buffer | ) |
| overridevirtual

Submit the command buffer that renders to the onscreen surface.

Reimplemented from impeller::Context.

Definition at line 139 of file surface_context_vk.cc.

140 {
141 swapchain_->AddFinalCommandBuffer(std::move(cmd_buffer));
142 return true;
143 }

## ◆ TeardownSwapchain()

void impeller::SurfaceContextVK::TeardownSwapchain | ( |  | ) |

Can be called when the surface is destroyed to reduce memory usage.

Definition at line 75 of file surface_context_vk.cc.

75 {
76 // When background the application, tear down the swapchain to release memory
77 // from the images. When returning to the foreground, SetWindowSurface will be
78 // called which will re-create the swapchain.
79 swapchain_.reset();
80 }

Referenced by impeller::testing::TEST().

## ◆ UpdateSurfaceSize()

void impeller::SurfaceContextVK::UpdateSurfaceSize | ( | const ISize & | size | ) | const

Mark the current swapchain configuration as dirty, forcing it to be recreated on the next frame.

Definition at line 110 of file surface_context_vk.cc.

110 {
111 swapchain_->UpdateSurfaceSize(size);
112 }

The documentation for this class was generated from the following files:

- impeller/renderer/backend/vulkan/surface_context_vk.h
- impeller/renderer/backend/vulkan/surface_context_vk.cc